Foreman - Bug #13817

ENC smart proxy validation fails
02/19/2016 04:10 PM - Matthew Ceroni

Status: Closed
Priority: Normal
Assignee: Matthew Ceroni
Category: Security
Target version: 1.11.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases: 1.11.0
Bugzilla link: 1326036 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3213,
https://github.com/theforeman/foreman/p
ull/3277
Description

Using latest nightly and encountered the following error: No smart proxy server found on [] and is not in trusted_puppetmaster_hosts
As you can see it wasn't listing the connecting smart proxy / host. Dug into the code and found the following section of code:

if certificate.subject_alternative_names

request_hosts += certificate.subject_alternative_names
elsif certificate.subject

request_hosts << certificate.subject

end

Testing of certificate.subject_alternative_names always evaluates to true even when no SAN. This results in request_hosts to be
empty and authentication of the request fails.

Related issues:
Related to Foreman - Feature #12127: Foreman should verify x509 subject alter... Closed 10/09/2015

Associated revisions

Revision f441da9d - 03/06/2016 02:40 AM - cyrus-mc

fixes #13817 - test certificate.subject_alternative_names for presence

Otherwise certificate SAN test is always true even with no SAN. This
results in request_hosts being empty and thus ENC authentication fails.

With test by Dominic Cleal <dominic@cleal.org>
Revision 35b10472 - 03/10/2016 10:56 AM - cyrus-mc
fixes #13817 - test certificate.subject_alternative_names for presence

Otherwise certificate SAN test is always true even with no SAN. This
results in request_hosts being empty and thus ENC authentication fails.

With test by Dominic Cleal <dominic@cleal.org>

(cherry picked from commit f441da9df0f835b1db166724c6ebbc2a695bc498)

History

#1 - 02/19/2016 04:12 PM - Matthew Ceroni

Created pull request to fix issue:

[[https://github.com/theforeman/foreman/pull/3213]]
#2 - 02/19/2016 05:08 PM - Anonymous

- Category set to Security

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3213 added

#3 - 02/22/2016 05:35 AM - Dominic Cleal
- Assignee set to Matthew Ceroni

- translation missing: en.field_release set to 71

#4 - 02/22/2016 05:35 AM - Dominic Cleal

- Related to Feature #12127: Foreman should verify x509 subject alternative names when authenticating a smart proxy added

#5 - 03/04/2016 10:40 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/3277 added

#6 - 03/06/2016 03:01 AM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset {441da9df0{835b1db166724c6ebbc2a695bc498.

#7 - 04/11/2016 11:56 AM - Bryan Kearney
- Bugzilla link set to 1326036
